wxWidgets: wxScopedArray< T > Class Template Reference

| Version: 3.0.5

- Main Page
- Related Pages
- Categories
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Modules Pages
Public Types | Public Member Functions | List of all members
wxScopedArray< T > Class Template Reference
Class List by Category » Smart Pointers

`#include <wx/scopedarray.h>`

## Detailed Description

### template<class T>
class wxScopedArray< T >

A scoped array template class.

This is a simple scoped smart pointer array implementation that is similar to the Boost smart pointers (see http://www.boost.org/) but rewritten to use macros instead.

This class is similar to boost scoped_array class: http://www.boost.org/doc/libs/1_37_0/libs/smart_ptr/scoped_array.htm

Notice that objects of this class intentionally cannot be copied.

##

Library: wxBase
Category: Smart Pointers

Example:

Below is an example of using a wxWidgets scoped smart pointer and pointer array.

class MyClass { ... };
// declare a smart pointer to a MyClass called wxMyClassPtr
wxDECLARE_SCOPED_PTR(MyClass, wxMyClassPtr)
// declare a smart pointer to an array of chars
wxDECLARE_SCOPED_ARRAY(char, wxCharArray)
...
// define the first pointer class, must be complete
wxDEFINE_SCOPED_PTR(MyClass, wxMyClassPtr)
// define the second pointer class
wxDEFINE_SCOPED_ARRAY(char, wxCharArray)
// create an object with a new pointer to MyClass
wxMyClassPtr theObj(new MyClass());
// reset the pointer (deletes the previous one)
theObj.reset(new MyClass());
// access the pointer
theObj->MyFunc();
// create an object with a new array of chars
wxCharArray theCharObj(new char[100]);
// access the array
theCharObj[0] = "!";

Declaring new smart pointer types:

wxDECLAR_SCOPED_ARRAY( TYPE, // type of the values
CLASSNAME ); // name of the class

A smart pointer holds a pointer to an object (which must be complete when wxDEFINE_SCOPED_ARRAY() is called).

The memory used by the object is deleted when the smart pointer goes out of scope. The first argument of the macro is the pointer type, the second is the name of the new smart pointer class being created. Below we will use wxScopedArray to represent the scoped pointer array class, but the user may create the class with any legal name.

##

Library: wxBase
Category: Smart Pointers

See also
  wxScopedPtr

## Public Types
typedef T | element_type
| The type of the array elements. More...

## Public Member Functions
| wxScopedArray (type *T=NULL)
| Creates the smart pointer with the given pointer or none if NULL. More...
const T * | get ()
| This operator gets the pointer stored in the smart pointer or returns NULL if there is none. More...
const T & | operator[] (long int i)
| This operator acts like the standard [] indexing operator for C++ arrays. More...
| reset (T *p=NULL)
| Deletes the currently held pointer and sets it to 'p' or to NULL if no arguments are specified. More...
| swap (wxScopedArray &ot)
| Swap the pointer inside the smart pointer with ot. More...
| wxScopedArray (T *array=NULL)
| Constructor takes ownership of the given array. More...
| ~wxScopedArray ()
| Destructor destroy the array. More...
| operator unspecified_bool_type () const
| Conversion to a boolean expression (in a variant which is not convertible to anything but a boolean expression). More...
void | reset (T *array=NULL)
| Change the array pointer stored. More...
T & | operator[] (size_t n) const
| Return the n-th element of the array. More...
T * | get () const
| Return the array pointer. More...
void | swap (wxScopedArray &other)
| Swaps the contents of this array with another one. More...

## Member Typedef Documentation

template<class T >

typedef T wxScopedArray< T >::element_type

The type of the array elements.

## Constructor & Destructor Documentation

template<class T >

wxScopedArray< T >::wxScopedArray | ( | type * | T = `NULL` | ) |

Creates the smart pointer with the given pointer or none if NULL.

On compilers that support it, this uses the explicit keyword.

template<class T >

wxScopedArray< T >::wxScopedArray | ( | T * | array = `NULL` | ) |
| explicit

Constructor takes ownership of the given array.

If array is NULL, reset() must presumably be called later.

Parameters

  array | An array allocated using `new`[] or NULL.

template<class T >

wxScopedArray< T >::~wxScopedArray | ( |  | ) |

Destructor destroy the array.

## Member Function Documentation

template<class T >

const T* wxScopedArray< T >::get | ( |  | ) |

This operator gets the pointer stored in the smart pointer or returns NULL if there is none.

template<class T >

T* wxScopedArray< T >::get | ( |  | ) | const

Return the array pointer.

The returned pointer may be NULL. It must not be deleted by the caller, call `reset(NULL)` instead.

template<class T >

wxScopedArray< T >::operator unspecified_bool_type | ( |  | ) | const

Conversion to a boolean expression (in a variant which is not convertible to anything but a boolean expression).

If this class contains a valid array it will return true, if it contains a NULL pointer it will return false.

template<class T >

const T& wxScopedArray< T >::operator[] | ( | long int | i | ) |

This operator acts like the standard [] indexing operator for C++ arrays.

The function does not do bounds checking.

template<class T >

T& wxScopedArray< T >::operator[] | ( | size_t | n | ) | const

Return the n-th element of the array.

Must not be called if the array has no valid pointer.

template<class T >

wxScopedArray< T >::reset | ( | T * | p = `NULL` | ) |

Deletes the currently held pointer and sets it to 'p' or to NULL if no arguments are specified.

This function does check to make sure that the pointer you are assigning is not the same pointer that is already stored.

template<class T >

void wxScopedArray< T >::reset | ( | T * | array = `NULL` | ) |

Change the array pointer stored.

The previously stored array is deleted.

Parameters

  array | An array allocated using `new`[] or NULL.

template<class T >

wxScopedArray< T >::swap | ( | wxScopedArray< T > & | ot | ) |

Swap the pointer inside the smart pointer with ot.

The pointer being swapped must be of the same type (hence the same class name).

template<class T >

void wxScopedArray< T >::swap | ( | wxScopedArray< T > & | other | ) |

Swaps the contents of this array with another one.